1.两数之和Java版,每日一题系列(此题来自力扣网)
给定一个整数数组 nums
和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。
你可以假设每种输入只会对应一个答案。但是,数组中同一个元素不能使用两遍。
实例:
给定 nums = [2, 7, 11, 15], target = 9
因为 nums[0] + nums[1] = 2 + 7 = 9
所以返回 [0, 1]
方法一:暴力法
暴力法很简单,遍历每个元素x,并查找是否存在一个值与target-x相等的目标元素。
class Solution {
// 举例nums = [2,7,11,15]; target = 9;
public int[] twoSum(int[] nums, int target) {
// 遍历nums数组
for (int i = 0; i < nums.length; i++) {
// 再次遍历数组nums,初始值为j=i+1
for (int j = i + 1; j < nums.length; j++) {
// 判断nums[j]+nums[i]=target
if (nums[j] == target - nums[i]) {
// 等式成立直接返回i和j
return new int[] { i, j };
}
}
}
// 等式不成立返回一个没有结果
throw new IllegalArgumentException("没有结果!");
}
}
方法二:哈希表
在进行迭代并将元素插入到表中的同时,我们还会回过头来检查表中是否已经存在当前元素所对应的目标元素。如果它存在,那我们已经找到了对应解,并立即将其返回。
class Solution {
// 举例nums = [2,7,11,15]; target = 9;
public int[] twoSum(int[] nums, int target) {
// 定义一个数组map,键和值都为整数
Map<Integer, Integer> map = new HashMap<>();
// 遍历nums数组
for (int i = 0; i < nums.length; i++) {
// 定义变量complement储存target - nums[i]的计算结果
int complement = target - nums[i];
// 判断map集合里是否有key的值和complement相等
if (map.containsKey(complement)) {
// 有相等的key值,则输出其key值对应的value值和i
return new int[] { map.get(complement), i };
}
// 把nums[i]当做map的key值,nums数组i下班当做map的value值
map.put(nums[i], i);
}
// 等式不成立返回一个没有结果
throw new IllegalArgumentException("没有结果!");
}
}
作者:LeetCode
链接:https://leetcode-cn.com/problems/two-sum/solution/liang-shu-zhi-he-by-leetcode-2/
来源:力扣(LeetCode)
著作权归作者所有。商业转载请联系作者获得授权,非商业转载请注明出处。